//+------------------------------------------------------------------+
//|                                               DocExpert_v1.4.mq5 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      " "
#property version   "1.00"

#include <Trade\DealInfo.mqh>
#include <MQL4_Lib.mqh>


//---- input parameters
input  string     Expert_Name          = "---- DocExpert_v1.4 ----";

input  int        Magic                =  281263;     // Magic Number
input  int        Slippage             =     300;     // Slippage in pips
 
input  int        CommentMode          =       1;     // Comments Mode: 0-off,1-on 
input  int        DebugMode            =       1;     // Debugging Mode: 0-off,1-on


input  string     Time_Inputs          = "---- Timing parameters ----";

input  int        StartHour            =       0;     // Start Hour of Trade Session 
input  int        StartMinute          =      30;     // Start Minute of Trade Session 
input  int        EndHour              =      23;     // End Hour of Trade Session
input  int        EndMinute            =      20;     // End Hour of Trade Session
input  int        MonStartHour         =       0;     // Monday Start Hour of Trade Session 
input  int        MonStartMinute       =       0;     // Monday Start Minute of Trade Session 
input  int        FriEndHour           =      12;     // Friday End Hour of Trade Session
input  int        FriEndMinute         =      30;     // Friday End Hour of Trade Session
input  int        TradeDay             =      -1;     // Trade Day of Week (ex.1-Monday,-1-all Days)
input  int        NonTradeDay          =       0;     // Non-Trading Day of Week (ex.5-Friday)   


input  string     MM_inputs            = "---- MoneyManagement ----";
input double      LotsPct              =      0.1;    // LotsPct in one-hundredth of % 
input double      MinPips              =      10;     // Min Pips to Win
input  int        maxspread            =      200;    // max spread

input  string     Indy_parameters      = "---- Indy parameters ----";
input double      Period1              =      0.1;    // LotsPct in one-hundredth of % 
input double      Period2              =      10;     // Min Pips to Win                            
                        
                             
                             
int handle_firstindicator,handle_secondindicator;
double firstindicator[],secondindicator[];
int  spread,OpenBuySignal,OpenSellSignal,CloseBuySignal,CloseSellSignal;
       
                             
                             
MqlTradeRequest trReq;
MqlTradeResult trRez;

int MainTimeFrame = -1;

double   _point, minstop;
datetime pTime, ptTime, TouchTime, pTouchTime;
int      TriesNum=5;
double   Balance, pBalance; 

double   contract, lot_min, lot_step, lot_max, tick_val;
bool     ftime, firstTime, istart;
int      touch, dir =0, PivotsNum, StopCycle = 0;
string   MMSystem, gTime;

double   aPivot[], ZeroLevel, nPivot[], pClose;
string   pCloseDate;


int      Start_h, MonStart_h, MonStart_min, FriEnd_h, FriEnd_min;
double   lots, incr, InitBalance, i_lots, i_incr;

MqlTick  tick;            //
MqlTick  first_tick;      //
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   ZeroMemory(trReq);
   ZeroMemory(trRez);
   
   
   _point   = _Point*MathPow(10,_Digits%2);
   minstop  = SymbolInfoInteger(Symbol(),SYMBOL_TRADE_STOPS_LEVEL)/MathPow(10,_Digits%2);
   lot_min  = SymbolInfoDouble(Symbol(),SYMBOL_VOLUME_MIN);
   lot_step = SymbolInfoDouble(Symbol(),SYMBOL_VOLUME_STEP);
   lot_max  = SymbolInfoDouble(Symbol(),SYMBOL_VOLUME_MAX);
   tick_val = SymbolInfoDouble(Symbol(),SYMBOL_TRADE_TICK_VALUE)*MathPow(10,_Digits%2);
   
   
   trReq.symbol=_Symbol;
   trReq.magic=Magic;
   trReq.deviation=Slippage;
   trReq.action=TRADE_ACTION_DEAL;
   trReq.type_filling=ORDER_FILLING_FOK;

   

//----
   Start_h = StartHour; 
   MonStart_h = MonStartHour; 
   MonStart_min = MonStartMinute; 
   FriEnd_h = FriEndHour; 
   FriEnd_min = FriEndMinute;
   
   
   
   firstTime = true;
   ftime = true;
   istart = true;
   
//---
//---- Create handle for 2 MA indicators
  handle_firstindicator     = iCustom(Symbol(),0,"myindi", Period1);  
  handle_secondindicator     = iCustom(Symbol(),0,"myindi", Period2); 
  if(handle_firstindicator==INVALID_HANDLE || handle_secondindicator==INVALID_HANDLE)
     {
      Print("Error in loading of EMA_RSI_VA. GetLastError() = ",GetLastError());
      return(-1);
     } 

   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
//---

}
//---

bool TimeCondition()
{
   bool tresult = false;
   double MonStart, FriEnd;
   datetime MonSessionStart, FriSessionEnd;
   
   if(((TradeDay >= 0 && DayOfWeek() == TradeDay) || TradeDay == -1) && DayOfWeek()!= NonTradeDay)
   {
      if(Start_h == 24) Start_h = 0; 
      
      datetime SessionStart = StringToTime((string)Start_h+":"+(string)StartMinute);
      double Start = Start_h + StartMinute/60.0;
      datetime SessionEnd   = StringToTime((string)EndHour+":"+(string)EndMinute);
      double End   = EndHour + EndMinute/60.0; 
   
      if(DayOfWeek() != 1 && DayOfWeek() != 5)
      {    
         if (Start < End) tresult = (TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd);      
         else
         if (Start > End)
         tresult = (TimeCurrent() >= SessionStart && TimeCurrent() < StringToTime((string)23+":"+(string)59))
                ||(TimeCurrent() >= StringToTime((string)0+":"+(string)0) && TimeCurrent() < SessionEnd);
      }
      else
      if(DayOfWeek() == 1)
      {    
      if(MonStart_h < 0 || MonStart_min < 0) {MonStart_h = Start_h; MonStart_min = StartMinute;}
         
         if(MonStart_h > 0 || MonStart_min > 0) 
         {
         MonSessionStart = StringToTime((string)MonStart_h+":"+(string)MonStart_min);
         MonStart = MonStart_h + MonStart_min/60.0;
         }
         else
         {
         MonSessionStart = StringToTime((string)0+":"+(string)0); //SessionStart;
         MonStart = 0;//Start;
         }
            
         if (Start < End)
         { 
            if (MonStart != 0) tresult = TimeCurrent() >= MonSessionStart && TimeCurrent() < SessionEnd;      
            else tresult = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd;
         }
         else
         if (Start > End)
         {
         tresult = (TimeCurrent() >= MonSessionStart && TimeCurrent() < SessionEnd) 
                  ||(TimeCurrent() >= SessionStart && TimeCurrent() < StringToTime((string)23+":"+(string)59));
         }
      }
      else
      if(DayOfWeek() == 5)
      {
      if(FriEnd_h < 0 || FriEnd_min < 0) {FriEnd_h = EndHour; FriEnd_min = EndMinute;}   
         if(FriEnd_h > 0 || FriEnd_min > 0)
         {
         FriSessionEnd   = StringToTime((string)FriEnd_h+":"+(string)FriEnd_min);
         FriEnd   = FriEnd_h + FriEnd_min/60.0; 
         }
         else
         {
         FriSessionEnd   = SessionEnd;
         FriEnd = End; 
         }
            
         if (Start < End)
         {
         if (FriEnd != End) tresult = TimeCurrent() >= SessionStart && TimeCurrent() < FriSessionEnd; 
         else
         tresult = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd;  
         }
         else
         if (Start > End)
         tresult = (TimeCurrent() >= StringToTime((string)0+":"+(string)0) && TimeCurrent() < SessionEnd)
                ||(TimeCurrent() >= SessionStart && TimeCurrent() < FriSessionEnd);
      }  
   }
   return(tresult);
}   



// ---- Scan Trades
int ScanTrades(int mode)
{   
   int total = PositionsTotal();
   int numpos = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   string sSymbol=PositionGetSymbol(cnt);
      if(PositionSelect(sSymbol) == true && sSymbol == _Symbol && PositionGetInteger(POSITION_MAGIC) == Magic) 
      {
      if(mode < 0) numpos++;
      else
      if(mode == OP_BUY  && PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_BUY ) numpos++;
      else
      if(mode == OP_SELL && PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_SELL) numpos++;
      }
   }
    
   return(numpos);
}  

///////////////////////////////////////////////////////////////////////////////////


double TotalProfit(int mode)
{
   int total = PositionsTotal();
   double profit = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   string sSymbol=PositionGetSymbol(cnt);
      if(PositionSelect(sSymbol) == true && sSymbol == _Symbol && PositionGetInteger(POSITION_MAGIC) == Magic) 
      {
      double open  = PositionGetDouble(POSITION_PRICE_OPEN);
      double close = PositionGetDouble(POSITION_PRICE_CURRENT);
      
         if(mode == 1)
         {
         if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_BUY ) profit = (close - open)/_point;
         else
         if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_SELL) profit = (open - close)/_point;
         }
         else
         profit = PositionGetDouble(POSITION_PROFIT) + PositionGetDouble(POSITION_SWAP) + PositionGetDouble(POSITION_COMMISSION);
      }
   }
    
   return(profit);
}

//partenza -1 short 0 long 1

int getLastOrderType(string forSymbol)
{
   if (HistorySelect(0,TimeCurrent()))
   {        
      int  totalPastOrders = HistoryOrdersTotal();
      uint lastOrderType   = -1;
      while(totalPastOrders>0 && !IsStopped())
      {
         ulong ticket = HistoryOrderGetTicket(totalPastOrders-1);
           if (ticket > 0 && (string)HistoryOrderGetString(ticket,ORDER_SYMBOL)==forSymbol) 
           {
               lastOrderType = (uint)HistoryOrderGetInteger(ticket,ORDER_TYPE); break;
           }
           else totalPastOrders--;
      }
      return((int)lastOrderType);
   }               
   return(-1);
}  

void ChartComment()
{
   string sComment   = "";
   string sp         = "----------------------------------------\n";
   string NL         = "\n";
   double pips = TotalProfit(1);
   double usd  = TotalProfit(0);

      
   sComment = sp;
   sComment = sComment+"Expert Name : "+Expert_Name+NL;
   sComment = sComment+sp;
   sComment = sComment+"Time: Current= "+TimeToString(TimeCurrent()) + NL;
   sComment = sComment+"Position: BUY="+(string)ScanTrades(OP_BUY)+" SELL= "+(string)ScanTrades(OP_SELL)+NL;
   sComment = sComment+"Current Profit(pips)= " + DoubleToString(pips,1) + NL;
   sComment = sComment+"Current Profit(USD) = " + DoubleToString(usd,2)  + NL;
   //sComment = sComment+"Current G signal    = " + DoubleToString(utotall_6)  + NL;
   sComment = sComment+"Last deal was    = " + DoubleToString(getLastOrderType(_Symbol))  + NL;
   sComment = sComment+sp;
 
   Comment(sComment);
}
//-----
 
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
  
 
//---
   SymbolInfoTick(_Symbol, tick);
   
   spread=int(SymbolInfoInteger(_Symbol,SYMBOL_SPREAD));
   
   //==================
//-------
              
                ArraySetAsSeries(firstindicator, true);
   if(CopyBuffer(handle_firstindicator, 0, 0, 4, firstindicator) < 0)

                return;
                
                ArraySetAsSeries(secondindicator, true);
   if(CopyBuffer(handle_secondindicator, 1, 0, 4, secondindicator) < 0)

                return;
                

                
//==================          

//--- get current Bid
   double curBidVal=SymbolInfoDouble(Symbol(),SYMBOL_BID);
   
   bool timecond = TimeCondition();
   double pips = TotalProfit(1);
   
	if((firstindicator[0]>secondindicator[0])&&(spread<=maxspread)&& timecond && getLastOrderType(_Symbol)!=1) OpenBuySignal  = 1;
	if((firstindicator[0]<secondindicator[0])&&(spread<=maxspread)&& timecond && getLastOrderType(_Symbol)!=0) OpenSellSignal = 1;
	
	if(((firstindicator[0]<secondindicator[0])&&(spread<=maxspread))) CloseBuySignal  = 1;
	if(((firstindicator[0]>secondindicator[0])&&(spread<=maxspread))) CloseSellSignal = 1;
	     
   //--- Do we have positions opened already?
   bool Buy_opened=false;  // variable to hold the result of Buy opened position
   bool Sell_opened=false; // variables to hold the result of Sell opened position

   if(PositionSelect(_Symbol)==true) // we have an opened position
     {
      if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
        {
         Buy_opened=true;  //It is a Buy
        }
      else if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
        {
         Sell_opened=true; // It is a Sell
        }
     }

  if(PositionSelect(_Symbol)==false) // we have no opened position
  {     
  lots = 0.0001*LotsPct*AccountInfoDouble(ACCOUNT_BALANCE);              
      //---- If MAPeriod > MAPeriod+2 -> BUY
      if(OpenBuySignal  == 1)
        {       
         trReq.volume=lots;                      // Requested volume for a deal in lots   
         trReq.price=tick.ask;                   // SymbolInfoDouble(NULL,SYMBOL_ASK);
         trReq.type=ORDER_TYPE_BUY;              // Order type
         OrderSend(trReq,trRez);
        }

        else if(OpenSellSignal == 1)
        {
         trReq.volume=lots;                      // Requested volume for a deal in lots         
         trReq.price=tick.bid;
         trReq.type=ORDER_TYPE_SELL;             // Order type
         OrderSend(trReq,trRez);
        }
      }
      
    if(PositionSelect(_Symbol)==true) // we have an opened position       
      {  
        if (Buy_opened)
         { 
         if(CloseBuySignal==1)
          {            
            trReq.volume=POSITION_VOLUME;
            trReq.type=ORDER_TYPE_SELL;              // Order type
            OrderSend(trReq,trRez);
            Print("close buy");           
         }
        } 
         else if (Sell_opened)
            {     
            if (CloseSellSignal==1)
            {                
            trReq.volume=POSITION_VOLUME;
            trReq.type=ORDER_TYPE_BUY;              // Order type
            OrderSend(trReq,trRez);
            Print("close sell");          
           }   

       }
  }
} 
  
//+------------------------------------------------------------------+
